<?php

namespace Opencart\Catalog\Model\Extension\Axepta\Payment;

use Axepta\Payment\Util;

/**
 * Class Axepta
 */
class Axepta extends \Opencart\System\Engine\Model
{

	const CODE = 'axepta';

	/**
	 * @param $address
	 *
	 * @return void
	 */
	public function getMethod($address)
	{
		$this->getMethod($address);
	}

	/**
	 * @param $address
	 *
	 * @return array
	 */
	public function getMethods($address)
	{

		$this->load->model('setting/setting');
		$this->load->language('extension/axepta/payment/axepta');

		include_once(DIR_EXTENSION . 'axepta/system/library/payment-core/vendor/autoload.php');

		$order_currency = $this->session->data['currency'];

		$method_data = [];

		if(Util::canUseForCurrency(strtoupper($order_currency), ($this->config->get('payment_axepta_currencies')
				?: []))
			&& $this->config->get('payment_axepta_authorization_token')
			&& $this->config->get('payment_axepta_service_key')
			&& $this->config->get('payment_axepta_service_id')
			&& $this->config->get('payment_axepta_merchant_id')) {

			$paymentTitle = $this->config->get('axepta_payment_title')
				?: $this->language->get('text_axepta_payment_title_default');

			$paymentTitle = $this->config->get('axepta_sandbox') == 1
				? $paymentTitle . ' ' . $this->language->get('title_sandbox_enabled')
				: $paymentTitle;

			$option_data['axepta'] = [
				'code' => 'axepta.axepta',
				'name' => $paymentTitle,
			];

			$method_data = [
				'code'       => self::CODE,
				'title'      => $paymentTitle,
				'name'       => $paymentTitle,
				'option'     => $option_data,
				'sort_order' => $this->config->get('payment_axepta_sort_order'),
			];
		}

		return $method_data;
	}
}
